## open-coarrays 2.10.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

cmake_policy(VERSION 3.19...3.23)

if(DEFINED ENV{SOURCE_DATE_EPOCH})
  set(SOURCE_DATE_EPOCH "$ENV{SOURCE_DATE_EPOCH}")
endif()

set(CMAKE_SKIP_RPATH ON
  CACHE BOOL "Don't add a build-dir rpath")
set(CMAKE_BUILD_WITH_INSTALL_RPATH ON
  CACHE BOOL "Build using the install rpath")
set(CMAKE_BUILD_RPATH_USE_ORIGIN ON
  CACHE BOOL "Use relative rpaths")
# Set the type/configuration of build to perform
set ( CMAKE_CONFIGURATION_TYPES "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "CodeCoverage" )
set ( CMAKE_BUILD_TYPE "Release"
  CACHE STRING "Select which configuration to build." )
set_property ( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${CMAKE_CONFIGURATION_TYPES} )

# Add option and check environment to determine if developer tests should be run
set( _TF OFF )
if( NOT DEFINED ENV{OPENCOARRAYS_DEVELOPER})
  set ( ENV{OPENCOARRAYS_DEVELOPER} FALSE )
endif()
if($ENV{OPENCOARRAYS_DEVELOPER})
  set( _TF ON )
endif()
option(CAF_RUN_DEVELOPER_TESTS "Run tests intended only for developers" ${_TF})
mark_as_advanced(CAF_RUN_DEVELOPER_TESTS)

# Name project and specify source languages
# Parse version from .VERSION file so that more info can be added and easier to get from scripts
file(STRINGS ".VERSION" first_line
  LIMIT_COUNT 1
  )

string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"
  OpenCoarraysVersion "${first_line}")

if((NOT (OpenCoarraysVersion MATCHES "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?")) AND (EXISTS "${CMAKE_SOURCE_DIR}/.git"))
  find_package(Git QUIET)
  if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --abbrev=0
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      RESULT_VARIABLE git_status
      OUTPUT_VARIABLE git_output
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if((git_status STREQUAL "0") AND (git_output MATCHES "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"))
      set(OpenCoarraysVersion "${git_output}")
    endif()
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --always
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      RESULT_VARIABLE git_status
      OUTPUT_VARIABLE full_git_describe
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(NOT (git_status STREQUAL "0"))
      set(full_git_describe NOTFOUND)
    endif()
    # Create a source distribution target using git archive
    # e.g., `make dist` will package a release using current git state
    add_custom_target(dist
      COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_SOURCE_DIR}/cmake/makeDist.cmake" "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}"
      VERBATIM)
  else()
    message( WARNING "Could not find git executable!")
  endif()
endif()

if(NOT (OpenCoarraysVersion MATCHES "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"))
  message( WARNING "Could not extract version from git, falling back on .VERSION, line 3.")
  file(STRINGS ".VERSION" OpenCoarraysVersion
  REGEX "[0-9]+\\.[0-9]+\\.[0-9]+(-rc[0-9]+)?"
  )
endif()

if(NOT full_git_describe)
  set(full_git_describe ${OpenCoarraysVersion})
endif()

string(REGEX REPLACE "-rc[0-9]+$"
       ".0" OPENCOARRAYS_CMAKE_PROJECT_VERSION
       "${OpenCoarraysVersion}")

file(READ "${CMAKE_CURRENT_LIST_DIR}/cmake/Banner.txt.in" OC_BANNER)
string(CONFIGURE "${OC_BANNER}" OC_BANNER @ONLY)
string(STRIP "${OC_BANNER}" OC_BANNER)
message(STATUS "${OC_BANNER}")

if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/.git")
  message( STATUS "Build from git repository detected")
endif()

message( STATUS "Running with CMake from: ${CMAKE_COMMAND}" )
message( STATUS "Current source dir (for OpenCoarrays): ${CMAKE_CURRENT_SOURCE_DIR}")

project(opencoarrays VERSION "${OPENCOARRAYS_CMAKE_PROJECT_VERSION}" LANGUAGES C Fortran)

if(DEFINED CMAKE_BUILD_TYPE AND "${CMAKE_BUILD_TYPE}" MATCHES "[Rr][Ee][Ll]")
  if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-working-directory")
  endif()
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fdebug-prefix-map=\"${CMAKE_SOURCE_DIR}\"=.")
  if(CMAKE_C_COMPILER_ID MATCHES "GNU")
    set(CMAKE_C_FLAGS       "${CMAKE_C_FLAGS} -fno-working-directory")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fdebug-prefix-map=\"${CMAKE_SOURCE_DIR}\"=.")
endif()

message( STATUS "Building OpenCoarrays version: ${full_git_describe}" )
set(OpenCoarrays_dist_string "OpenCoarrays-${full_git_describe}")
message( STATUS "Building for target architecture: ${CMAKE_SYSTEM_PROCESSOR}" )

#Print an error message on an attempt to build inside the source directory tree:
if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  message(FATAL_ERROR "ERROR! "
    "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
    " == CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}"
    "\nThis archive does not support in-source builds:\n"
    "You must now delete the CMakeCache.txt file and the CMakeFiles/ directory under "
    "the 'src' source directory or you will not be able to configure correctly!"
    "\nYou must now run something like:\n"
    "  $ rm -r CMakeCache.txt CMakeFiles/"
    "\n"
    "Please create a directory outside the opencoarrays source tree and build under that outside directory "
    "in a manner such as\n"
    "  $ mkdir build-opencarrays\n"
    "  $ cd build-opencoarrays\n"
    "  $ CC=gcc FC=gfortran cmake -DBUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/path/to/install/dir /path/to/opencoarrays/src/dir \n"
    "\nsubstituting the appropriate syntax for your shell (the above line assumes the bash shell)."
    )
endif()

# Silence warnings about dereferencing unset variables
if(NOT CMAKE_REQUIRED_FLAGS)
  set(CMAKE_REQUIRED_FLAGS "")
endif()
if(NOT CMAKE_REQUIRED_DEFINITIONS)
  set(CMAKE_REQUIRED_DEFINITIONS "")
endif()
if(NOT CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_REQUIRED_LIBRARIES "")
endif()
if(NOT CMAKE_REQUIRED_INCLUDES)
  set(CMAKE_REQUIRED_INCLUDES "")
endif()

#Report untested Fortran compiler unless explicitly directed to build all examples.
if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU" )
  set(gfortran_compiler true)
  set ( CMAKE_C_FLAGS_CODECOVERAGE "-fprofile-arcs -ftest-coverage -O0"
    CACHE STRING "Code coverage C compiler flags")
  set ( CMAKE_Fortran_FLAGS_CODECOVERAGE "-fprofile-arcs -ftest-coverage -O0"
    CACHE STRING "Code coverage Fortran compiler flags")
else()
  message(WARNING
    "\n"
    "Attempting to build with untested Fortran compiler: ${CMAKE_Fortran_COMPILER_ID}. "
    "Please report any failures to opencoarrays@googlegroups.com\n\n"
  )
endif()

#-----------------------------------------------------------------
# Set CMAKE_Fortran_COMPILER_VERSION if CMake doesn't do it for us
#-----------------------------------------------------------------
if (  NOT CMAKE_Fortran_COMPILER_VERSION )
  if ( NOT (CMAKE_VERSION VERSION_LESS 3.3.1) )
    message( AUTHOR_WARNING
     "CMake ${CMAKE_VERSION} should know about Fortran compiler versions but is missing CMAKE_Fortran_COMPILER_VERSION variable."
    )
  endif()
  # No CMAKE_Fortran_COMPILER_VERSION set, build our own
  # Try extracting it directly from ISO_FORTRAN_ENV's compiler_version
  # Write program for introspection
  file( WRITE "${CMAKE_BINARY_DIR}/get_compiler_ver.f90"
    "program main
     use iso_fortran_env, only: compiler_version, output_unit
     write(output_unit,'(a)') compiler_version()
end program"
  )
  try_run( PROG_RAN COMPILE_SUCCESS
    "${CMAKE_BINARY_DIR}" "${CMAKE_BINARY_DIR}/get_compiler_ver.f90"
    RUN_OUTPUT_VARIABLE VER_STRING
  )
  if ( COMPILE_SUCCESS )
    string( REGEX MATCH "[0-9]+\\.[0-9]+(\\.[0-9]+)?"
      DETECTED_VER "${VER_STRING}"
    )
    message( STATUS "Detected Fortran compiler as ${VER_STRING}" )
    message( STATUS "Extracted version number: ${DETECTED_VER}" )
  endif()
  if( ( NOT COMPILE_SUCCESS ) OR ( NOT DETECTED_VER ) )
    message( WARNING "Could not reliably detect Fortran compiler version. We'll infer it from
the C compiler if it matches the Fortran compiler ID." )
  endif()
  if( "${CMAKE_C_COMPILER_ID}" MATCHES "${CMAKE_Fortran_COMPILER_ID}" )
    set( DETECTED_VER "${CMAKE_C_COMPILER_VERSION}" )
  else()
    message( FATAL_ERROR "Exhausted all possible means of detecting the Fortran compiler version, cannot proceed!" )
  endif()
  set( CMAKE_Fortran_COMPILER_VERSION "${DETECTED_VER}" )
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug|DEBUG|debug")
  add_definitions(-DEXTRA_DEBUG_OUTPUT)
  set(IMPI_BUILD debug)
else()
  set(IMPI_BUILD release)
endif()

  # We have populated CMAKE_Fortran_COMPILER_VERSION if it was missing
  if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 5.0.0))
    set(opencoarrays_aware_compiler true)
    add_definitions(-DPREFIX_NAME=_gfortran_caf_)
  else()
    set(opencoarrays_aware_compiler false)
    add_definitions(-DPREFIX_NAME=_caf_extensions_)
  endif()
  if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 5.4.0))
    # GCC patch to fix issue accepted for 5.4 release
    # See https://github.com/sourceryinstitute/opencoarrays/issues/28 and
    # https://groups.google.com/forum/#!msg/opencoarrays/RZOwwYTqG80/46S9eL696dgJ
    message( STATUS "Disabling optimization flags due to GCC < 5.4 bug")
    set(CMAKE_Fortran_FLAGS_RELEASE -O0
      CACHE STRING "Flags used by the compiler during release builds." FORCE)
    set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-g -DNDEBUG -O0"
      CACHE STRING "Flags used by the compiler during release builds with debug info" FORCE)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -O0")
  endif()
  if ( gfortran_compiler AND ( NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0 ) )
    add_definitions(-DGCC_GE_7) # Tell library to build against GFortran 7.x bindings b/c we might be using clang for C
  endif()
  if ( gfortran_compiler AND ( NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 8.0.0 ) )
    add_definitions(-DGCC_GE_8) # Tell library to build against GFortran 8.x bindings w/ descriptor change
  endif()

if(gfortran_compiler)
  set(OLD_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS -fcoarray=single)
endif()
include(CheckFortranSourceCompiles)
CHECK_Fortran_SOURCE_COMPILES("
  program main
    implicit none
    integer :: i
    i = this_image()
  end program
" Check_Simple_Coarray_Fortran_Source_Compiles
  SRC_EXT F90)
if(gfortran_compiler)
  set (CMAKE_REQUIRED_FLAGS ${OLD_REQUIRED_FLAGS})
  unset(OLD_REQUIRED_FLAGS)
endif()


#----------------------------------------------------------------------------
# Find MPI and set some flags so that FC and CC can point to gfortran and gcc
#----------------------------------------------------------------------------

# If the user passes FC=mpifort etc. check and prefer that location
get_filename_component( FTN_COMPILER_NAME "${CMAKE_Fortran_COMPILER}"
  NAME )
get_filename_component( C_COMPILER_NAME "${CMAKE_C_COMPILER}"
  NAME )
get_filename_component( FTN_COMPILER_DIR "${CMAKE_Fortran_COMPILER}"
  REALPATH )
get_filename_component( C_COMPILER_DIR "${CMAKE_C_COMPILER}"
  REALPATH )

if (FTN_COMPILER_NAME MATCHES "^[mM][pP][iI]")
  message( DEPRECATION "Setting the Fortran compiler to an MPI wrapper script is deprecated!")
  set (MPI_Fortran_COMPILER "${CMAKE_Fortran_COMPILER}")
endif()
if (C_COMPILER_NAME MATCHES "^[mM][pP][iI]")
  message( DEPRECATION "Setting the Fortran compiler to an MPI wrapper script is deprecated!")
  set (MPI_C_COMPILER "${CMAKE_C_COMPILER}")
endif()

if(WIN32) # Only support building with GCC & GFortran using Intel MPI (OneAPI)
  # Here we assume Intel ONEAPI and the environment is loaded
  set( MPI_ASSUME_NO_BUILTIN_MPI TRUE )
  set( MPI_CXX_SKIP_MPICXX TRUE )
  cmake_path(SET MPI_ROOT NORMALIZE "$ENV{I_MPI_ROOT}")
  set (IMPI_LIB_DIR "${MPI_ROOT}/lib")
  set (IMPI_DLL_DIR "${MPI_ROOT}/bin")

  message(STATUS "Looking in IMPI_LIB_DIR=${IMPI_LIB_DIR}")
  message(STATUS "Looking in IMPI_DLL_DIR=${IMPI_DLL_DIR}")
  find_library(IMPI_LIB
    "impi.lib"
    HINTS "${IMPI_LIB_DIR}"
    PATH_SUFFIXES "${IMPI_BUILD}"
    DOC "Location of the Intel MPI impi.lib file"
    REQUIRED
    NO_DEFAULT_PATH)

=== src/application-binary-interface/CMakeLists.txt ===
install( FILES libcaf.h libcaf-gfortran-descriptor.h libcaf-version-def.h
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

=== src/runtime-libraries/CMakeLists.txt ===
add_subdirectory(mpi)

=== src/runtime-libraries/mpi/CMakeLists.txt ===
# Silence warnings about dereferencing unset variables
if(NOT CMAKE_REQUIRED_FLAGS)
  set(CMAKE_REQUIRED_FLAGS "")
endif()
if(NOT CMAKE_REQUIRED_DEFINITIONS)
  set(CMAKE_REQUIRED_DEFINITIONS "")
endif()
if(NOT CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_REQUIRED_LIBRARIES "")
endif()
if(NOT CMAKE_REQUIRED_INCLUDES)
  set(CMAKE_REQUIRED_INCLUDES "")
endif()

if (NOT MPI_C_FOUND)
  find_package(MPI REQUIRED)
endif()

#-----------------------------------------------------------
# Add the actual library targets, then adjust them as needed
#-----------------------------------------------------------
add_library(opencoarrays_mod STATIC ./opencoarrays.F90)
set_target_properties(opencoarrays_mod
  PROPERTIES
  Fortran_MODULE_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/${mod_dir_tail}"
  POSITION_INDEPENDENT_CODE TRUE)
target_compile_options(opencoarrays_mod
  PRIVATE $<$<COMPILE_LANGUAGE:Fortran>:${MPI_Fortran_COMPILE_OPTIONS}>)
target_compile_definitions(opencoarrays_mod
  PRIVATE $<$<COMPILE_LANGUAGE:Fortran>:${MPI_Fortran_COMPILE_DEFINITIONS}>)
target_link_libraries(opencoarrays_mod
  PUBLIC ${MPI_Fortran_LINK_FLAGS}
  PUBLIC ${MPI_Fortran_LIBRARIES})
target_link_libraries(opencoarrays_mod
  PUBLIC caf_mpi_static)
target_include_directories(opencoarrays_mod PUBLIC
  $<$<COMPILE_LANGUAGE:Fortran>:${MPI_Fortran_INCLUDE_DIRS}>
  $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/${mod_dir_tail}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${mod_dir_tail}>)

add_library(caf_mpi SHARED mpi_caf.c ../common/caf_auxiliary.c)
add_library(caf_mpi_static STATIC  mpi_caf.c ../common/caf_auxiliary.c)
target_link_libraries(caf_mpi
  PUBLIC ${MPI_C_LINK_FLAGS}
  PUBLIC ${MPI_C_LIBRARIES})
target_link_libraries(caf_mpi_static
  PUBLIC ${MPI_C_LINK_FLAGS}
  PUBLIC ${MPI_C_LIBRARIES})
set_target_properties(caf_mpi_static
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE)

set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

message(STATUS "Threads found? ${Threads_FOUND}")
message(STATUS "Thread library to use: ${CMAKE_THREAD_LIBS_INIT}")
message(STATUS "Found threads library pthread compatible? ${CMAKE_USE_PTHREADS_INIT}")

target_link_libraries(caf_mpi
  PUBLIC Threads::Threads)
set_target_properties(caf_mpi
  PROPERTIES LINKER_LANGUAGE Fortran)
target_link_libraries(caf_mpi_static
  PUBLIC Threads::Threads)
target_link_libraries(caf_mpi_static
  PRIVATE gfortran)

target_include_directories(caf_mpi PUBLIC
  $<$<COMPILE_LANGUAGE:C>:${MPI_C_INCLUDE_DIRS}>
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_include_directories(caf_mpi_static PUBLIC
  $<$<COMPILE_LANGUAGE:C>:${MPI_C_INCLUDE_DIRS}>
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_options(caf_mpi
  PUBLIC $<$<COMPILE_LANGUAGE:C>:${MPI_C_COMPILE_OPTIONS}>)
target_compile_definitions(caf_mpi
  PUBLIC $<$<COMPILE_LANGUAGE:C>:${MPI_C_COMPILE_DEFINITIONS}>)
target_compile_options(caf_mpi_static
  PUBLIC $<$<COMPILE_LANGUAGE:C>:${MPI_C_COMPILE_OPTIONS}>)
target_compile_definitions(caf_mpi_static
  PUBLIC $<$<COMPILE_LANGUAGE:C>:${MPI_C_COMPILE_DEFINITIONS}>)

set(CAF_SO_VERSION 0)
if(gfortran_compiler)
  if(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 8.0.0)
    set(CAF_SO_VERSION 3)
  elseif(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0)
    set(CAF_SO_VERSION 2)
  elseif(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 6.0.0)
    set(CAF_SO_VERSION 1)
  endif()
endif()

set_target_properties ( caf_mpi
  PROPERTIES
  SOVERSION ${CAF_SO_VERSION}
#  VERSION ${PROJECT_VERSION}
)

# Unfortunately caf_mpi.c calls a function directly from libgfortran and this can be resolved later
if(APPLE)
  set_target_properties ( caf_mpi
    PROPERTIES
    LINK_FLAGS "-undefined dynamic_lookup"
  )
endif()

# Create a symlink in the include dir
if(UNIX)
  add_custom_command(TARGET caf_mpi
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E create_symlink "./${mod_dir_tail}/opencoarrays.mod" "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/opencoarrays.mod"
    COMMENT "Creating symlink ${CMAKE_INSTALL_INCLUDEDIR}/opencoarrays.mod --> ${CMAKE_INSTALL_INCLUDEDIR}/${mod_dir_tail}/opencoarrays.mod")
endif()

install(DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  FILES_MATCHING PATTERN "opencoarrays.mod")

set_target_properties( caf_mpi_static
  PROPERTIES
  SOVERSION ${CAF_SO_VERSION}
#  VERSION ${PROJECT_VERSION}
)

if (gfortran_compiler)
  target_compile_options(caf_mpi INTERFACE $<$<COMPILE_LANGUAGE:Fortran>:-fcoarray=lib>)
  target_compile_options(caf_mpi_static INTERFACE $<$<COMPILE_LANGUAGE:Fortran>:-fcoarray=lib>)
endif()

install(TARGETS opencoarrays_mod caf_mpi caf_mpi_static EXPORT OpenCoarraysTargets
  DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)

#----------------------------------
# Determine if we're using Open MPI
#----------------------------------
cmake_host_system_information(RESULT N_CPU QUERY NUMBER_OF_LOGICAL_CORES)
set(N_CPU ${N_CPU} PARENT_SCOPE)
cmake_host_system_information(RESULT HOST_NAME QUERY HOSTNAME)
set(HOST_NAME ${HOST_NAME} PARENT_SCOPE)
execute_process(COMMAND ${MPIEXEC_EXECUTABLE} --version
  OUTPUT_VARIABLE mpi_version_out)
if (mpi_version_out MATCHES "[Oo]pen[ -][Mm][Pp][Ii]")
  message( STATUS "OpenMPI detected")
  set ( openmpi true PARENT_SCOPE)
  # Write out a host file because OMPI's mpiexec is dumb
  file(WRITE ${CMAKE_BINARY_DIR}/hostfile "${HOST_NAME} slots=${N_CPU}\n")
  message( STATUS "hostfile written to: ${CMAKE_BINARY_DIR}/hostfile")
  if(NOT DEFINED ENV{TRAVIS})
    message( STATUS "Open-MPI back end detected, passing --allow-run-as-root to allow tests to pass when run with sudo or as root." )
  endif()
endif ()

if("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU")
  set(gfortran_compiler true)
elseif("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "Cray")
  set(cray_compiler true)
elseif("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "PGI")
  set(portland_group_compiler true)
endif()

if(gfortran_compiler AND (NOT opencoarrays_aware_compiler))
  target_compile_definitions(opencoarrays_mod
    PUBLIC -DCOMPILER_SUPPORTS_CAF_INTRINSICS)
endif()

option(CAF_EXPOSE_INIT_FINALIZE "Expose caf_init and caf_finalize in opencoarrays module" FALSE)
if(CAF_EXPOSE_INIT_FINALIZE)
  target_compile_definitions(opencoarrays_mod
    PRIVATE -DEXPOSE_INIT_FINALIZE)
endif()

include(CheckIncludeFile)
CHECK_INCLUDE_FILE("alloca.h" HAVE_ALLOCA)
if(NOT HAVE_ALLOCA)
  target_compile_definitions(caf_mpi
    PRIVATE -DALLOCA_MISSING)
  target_compile_definitions(caf_mpi_static
    PRIVATE -DALLOCA_MISSING)
  message(WARNING "Could not find <alloca.h>. Assuming functionality is provided elsewhere.")
endif()

#----------------------------------------------------------------------
# Test if MPI implementation provides features needed for failed images
#----------------------------------------------------------------------
set(MPI_HAS_FAULT_TOL_EXT YES)

CHECK_INCLUDE_FILE("signal.h" HAVE_SIGNAL_H)
if (NOT HAVE_SIGNAL_H)
  set(MPI_HAS_FAULT_TOL_EXT NO)
  message( FATAL_ERROR "Currently, OpenCoarrays cannot build without signal.h")
endif()

include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(SIGKILL "signal.h" HAVE_SIGKILL)
if(NOT HAVE_SIGKILL) # try -D_POSIX, needed for mingw-w64, maybe others, see #435
                     # https://github.com/sourceryinstitute/OpenCoarrays/issues/435#issuecomment-323592433
  list( APPEND CMAKE_REQUIRED_DEFINITIONS -D_POSIX)
  CHECK_SYMBOL_EXISTS(SIGKILL "signal.h" HAVE_SIGKILL2)
  if(HAVE_SIGKILL2)
    set(HAVE_SIGKILL ${HAVE_SIGKILL2})
    foreach(lib caf_mpi caf_mpi_static)
      target_compile_definitions(${lib}
    	PUBLIC -D_POSIX)
    endforeach()
  endif()
endif()

if (NOT HAVE_SIGKILL)
  set(MPI_HAS_FAULT_TOL_EXT NO)
  message (FATAL_ERROR "Currently, OpenCoarrays cannot build without SIGKILL from signal.h")
endif()

set(NEEDED_SYMBOLS MPIX_ERR_PROC_FAILED;MPIX_ERR_REVOKED;MPIX_Comm_failure_ack;MPIX_Comm_failure_get_acked;MPIX_Comm_shrink;MPIX_Comm_agree)

set(old_cmake_required_includes "${CMAKE_REQUIRED_INCLUDES}")
if(CMAKE_REQUIRED_INCLUDES)
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${MPI_C_INCLUDE_DIRS})
else()
  set(CMAKE_REQUIRED_INCLUDES ${MPI_C_INCLUDE_DIRS})
endif()
set(old_cmake_required_flags "${CMAKE_REQUIRED_FLAGS}")
if(CMAKE_REQUIRED_FLAGS)
  set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS} ${MPI_C_COMPILE_OPTIONS} ${MPI_C_COMPILE_DEFINITIONS} ${MPI_C_LINK_FLAGS})
else()
  set(CMAKE_REQUIRED_FLAGS ${MPI_C_COMPILE_OPTIONS} ${MPI_C_COMPILE_DEFINITIONS} ${MPI_C_LINK_FLAGS})
endif()
set(old_cmake_required_libraries "${CMAKE_REQUIRED_LIBRARIES}")
if(CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${MPI_C_LIBRARIES})
else()
  set(CMAKE_REQUIRED_LIBRARIES ${MPI_C_LIBRARIES})
endif()

set(MPI_HEADERS mpi.h)
include(CheckIncludeFiles)
CHECK_INCLUDE_FILES("mpi.h;mpi-ext.h" HAVE_MPI_EXT)
if(HAVE_MPI_EXT)
    foreach(lib caf_mpi caf_mpi_static)
      target_compile_definitions(${lib}
    	PRIVATE -DHAVE_MPI_EXT_H)
    endforeach()
  set(MPI_HEADERS ${MPI_HEADERS};mpi-ext.h)
endif()

foreach(symbol ${NEEDED_SYMBOLS})
  CHECK_SYMBOL_EXISTS(${symbol} "${MPI_HEADERS}" HAVE_${symbol})
  if(NOT HAVE_${symbol})
    message( STATUS "\${HAVE_${symbol}} = ${HAVE_${symbol}}")
    message( STATUS
      "Note: Failed Images not supported by the current MPI implementation! (Needs MPIX experimental features--as of MPI3)")
    set(MPI_HAS_FAULT_TOL_EXT NO)
    break() # no need to keep looking
  endif()
endforeach(symbol)
set(CMAKE_REQUIRED_INCLUDES ${old_cmake_required_includes})
set(CMAKE_REQUIRED_FLAGS ${old_cmake_required_flags})
set(CMAKE_REQUIRED_LIBRARIES ${old_cmake_required_libraries})

if(MPI_HAS_FAULT_TOL_EXT) # AND (NOT openmpi))
  option(CAF_ENABLE_FAILED_IMAGES "Enable failed images support" FALSE)
  message(STATUS "The MPI implementation appears to have the experimental features for ULFM
that will allow you to build OpenCoarrays with failed images support. However,
ULFM support did not make it into the MPI-4 standard, and it is known to
trigger some bugs. Because of this we have disabled it by default. You may
add the `-DCAF_ENABLE_FAILED_IMAGES:BOOL=ON` CMake flag or edit the value
with ccmake or cmake-gui if you would like to experiment with failed images.")
else()
  set(CAF_ENABLE_FAILED_IMAGES FALSE
    CACHE
    BOOL
    "Enable failed images support (no support in the selected MPI implementation)"
    FORCE)
endif()

if(CAF_ENABLE_FAILED_IMAGES)
  foreach(lib caf_mpi caf_mpi_static)
    target_compile_definitions(${lib}
      PUBLIC -DUSE_FAILED_IMAGES)
  endforeach()
endif()

#---------------------------------------------------
# Windows Intel MPI compatibility, see GH issue #435
#---------------------------------------------------
set(old_cmake_required_includes "${CMAKE_REQUIRED_INCLUDES}")
if(CMAKE_REQUIRED_INCLUDES)
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${MPI_C_INCLUDE_DIRS})
else()
  set(CMAKE_REQUIRED_INCLUDES ${MPI_C_INCLUDE_DIRS})
endif()
CHECK_INCLUDE_FILES("mpi.h" HAVE_MPI_H)
CHECK_SYMBOL_EXISTS(I_MPI_VERSION "mpi.h" HAVE_Intel_MPI)
if(HAVE_Intel_MPI AND WIN32)
  foreach(lib caf_mpi caf_mpi_static)
    target_compile_definitions(${lib}
      PUBLIC -DUSE_GCC)
  endforeach()
endif()
set(CMAKE_REQUIRED_INCLUDES ${old_cmake_required_includes})

##############################################
# Configure `caf` and `cafrun` wrapper scripts
##############################################
# List of caf.in variables needing configuration:
#
# @CAF_VERSION@ @opencoarrays_aware_compiler@ @Fortran_COMPILER@ @CAF_MODDIR@
# @CAF_MPI_Fortran_LINK_FLAGS@ @CAF_MPI_Fortran_COMPILE_FLAGS@
# @CAF_LIBS@ @THREADS_LIB@ @CAF_MPI_LIBS@
#

set(CAF_VERSION "${full_git_describe}")
set(Fortran_COMPILER "${CMAKE_Fortran_COMPILER}")

=== src/tests/unit/CMakeLists.txt ===
if (${opencoarrays_aware_compiler})
  add_subdirectory(simple)
  add_subdirectory(send-get)
  add_subdirectory(init_register)
  add_subdirectory(collectives)
  add_subdirectory(sync)
  add_subdirectory(events)
  if (gfortran_compiler)
    if(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7)
      add_subdirectory(fail_images)
      if(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 8)
        add_subdirectory(teams)
      endif()
    endif()
  endif()
else()
  add_subdirectory(extensions)
endif()

=== src/tests/utilities/CMakeLists.txt ===
if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU" )
  set(OLD_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS "-fcoarray=single -ffree-form")
endif()

# Check support for Fortran 2018 error termination in a pure procedure
check_fortran_source_compiles("
  program main
  contains
    pure subroutine foo()
      error stop
    end subroutine
  end program
"
  HAVE_ERROR_STOP_IN_PURE
  SRC_EXT ".f90"
  )

# Check support for Fortran 2018 variable stop code
check_fortran_source_compiles("
  program main
    integer i
    i = 0
    error stop i
  end program
"
  HAVE_VARIABLE_STOP_CODE
  SRC_EXT ".f90")

if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU" )
  set(CMAKE_REQUIRED_FLAGS ${OLD_REQUIRED_FLAGS})
endif()

add_library( oc_test_interfaces OBJECT
  opencoarrays_object_interface.f90
  oc_assertions_interface.F90
  )
add_library( opencoarrays_test_utilities STATIC
  oc_assertions_implementation.F90
  $<TARGET_OBJECTS:oc_test_interfaces>
  )
set_target_properties(opencoarrays_test_utilities
  PROPERTIES
  Fortran_MODULE_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/${mod_dir_tail}")
set_target_properties(oc_test_interfaces
  PROPERTIES
  Fortran_MODULE_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/${mod_dir_tail}")

target_compile_options(oc_test_interfaces
  PUBLIC
  "-fcoarray=lib")
target_compile_options(opencoarrays_test_utilities
  PUBLIC
  "-fcoarray=lib")

if(HAVE_ERROR_STOP_IN_PURE)
  target_compile_definitions(oc_test_interfaces
    PUBLIC -DHAVE_ERROR_STOP_IN_PURE)
  target_compile_definitions(opencoarrays_test_utilities
    PUBLIC -DHAVE_ERROR_STOP_IN_PURE)
endif()
if(HAVE_VARIABLE_STOP_CODE)
  target_compile_definitions(oc_test_interfaces
    PUBLIC -DHAVE_VARIABLE_STOP_CODE)
  target_compile_definitions(opencoarrays_test_utilities
    PUBLIC -DHAVE_VARIABLE_STOP_CODE)
endif()

#Toggle C preprocessor macro for turning assertions on or off
if(NO_ASSERTIONS)
  target_compile_definitions( opencoarrays_test_utilities
    PUBLIC "-DUSE_ASSERTIONS=.false."
  )
else()
  target_compile_definitions( opencoarrays_test_utilities
    PUBLIC "-DUSE_ASSERTIONS=.true."
  )
endif()

=== src/tests/integration/coarrayHelloWorld/CMakeLists.txt ===
caf_compile_executable(hello_multiverse hello_multiverse.F90)

=== src/tests/unit/init_register/CMakeLists.txt ===
caf_compile_executable(initialize_mpi initialize_mpi.F90)
caf_compile_executable(register register.f90)
set_target_properties(build_register
  PROPERTIES MIN_IMAGES 2)
caf_compile_executable(register_vector register_vector.f90)
caf_compile_executable(register_alloc_vector register_alloc_vector.f90)
caf_compile_executable(allocate_as_barrier allocate_as_barrier.f90)
caf_compile_executable(allocate_as_barrier_proc allocate_as_barrier_proc.f90)

if (gfortran_compiler AND (NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0))
  caf_compile_executable(async_comp_alloc async_comp_alloc.f90)
  set_target_properties(build_async_comp_alloc
    PROPERTIES MIN_IMAGES 2)
  caf_compile_executable(async_comp_alloc_2 async_comp_alloc_2.f90)
  caf_compile_executable(register_alloc_comp_1 register_alloc_comp_1.f90)
  caf_compile_executable(register_alloc_comp_2 register_alloc_comp_2.f90)
  caf_compile_executable(register_alloc_comp_3 register_alloc_comp_3.f90)
  caf_compile_executable(comp_allocated_1 comp_allocated_1.f90)
  caf_compile_executable(comp_allocated_2 comp_allocated_2.f90)
elseif((CAF_RUN_DEVELOPER_TESTS OR $ENV{OPENCOARRAYS_DEVELOPER}))
  message( AUTHOR_WARNING "Skipping building the following tests due to GFortran < 7.x lack of compatibility:
    async_comp_alloc.f90
    async_comp_alloc_2.f90
    register_alloc_comp_1.f90
    register_alloc_comp_2.f90
    register_alloc_comp_3.f90
    comp_allocated_1.f90
    comp_allocated_2.f90" )
endif()

=== src/tests/unit/send-get/CMakeLists.txt ===
caf_compile_executable(get_array get_array_test.f90)

#caf_compile_executable(get old_get_array_test.f90)
#target_link_libraries(is_this_still_needed OpenCoarrays)

## Pure get() tests
caf_compile_executable(get_self sameloc.f90)
caf_compile_executable(get_convert_nums get_convert_nums.f90)
caf_compile_executable(get_convert_char_array get_convert_char_array.f90)
caf_compile_executable(get_with_offset_1d get_with_offset_1d.f90)
caf_compile_executable(whole_get_array whole_get_array.f90)
caf_compile_executable(strided_get strided_get.f90)
caf_compile_executable(get_with_vector_index get_with_vector_index.f90)
## Inquiry functions (these are gets that could be optimized in the future to communicate only the descriptors)
caf_compile_executable(alloc_comp_multidim_shape alloc_comp_multidim_shape.F90)
caf_compile_executable(get_static_array get_static_array.f90)

## Pure send() tests
caf_compile_executable(send_array send_array_test.f90)
if(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0)
  caf_compile_executable(send_convert_nums send_convert_nums.f90)
endif()
caf_compile_executable(send_with_vector_index send_with_vector_index.f90)

# Pure sendget() tests
caf_compile_executable(sendget_convert_char_array sendget_convert_char_array.f90)
if(NOT CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0)
  caf_compile_executable(sendget_convert_nums sendget_convert_nums.f90)
endif()
caf_compile_executable(send_convert_char_array send_convert_char_array.f90)
#caf_compile_executable(sendget_with_vector_index sendget_with_vector_index.f90)
caf_compile_executable(strided_sendget strided_sendget.f90)
set_target_properties(build_strided_sendget
  PROPERTIES MIN_IMAGES 3)

# Allocatable components w/ convert
if((NOT (CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 7.0.0)) OR (CAF_RUN_DEVELOPER_TESTS OR $ENV{OPENCOARRAYS_DEVELOPER}))
  caf_compile_executable(alloc_comp_get_convert_nums alloc_comp_get_convert_nums.f90)
  caf_compile_executable(alloc_comp_send_convert_nums alloc_comp_send_convert_nums.f90)
endif()

=== src/tests/unit/simple/CMakeLists.txt ===
# Fortran tests

caf_compile_executable(increment_my_neighbor increment_neighbor.f90)
caf_compile_executable(atomics testAtomics.f90)
caf_compile_executable(random_init random_init.f90)

# C tests
#include(CMakeForceCompiler)
#CMAKE_FORCE_C_COMPILER(mpicc GNU)
#add_executable(C_sync_images syncimages2.c ../../../mpi/mpi_caf.c ../../../common/caf_auxiliary.c)

=== src/tests/integration/pde_solvers/coarrayBurgers/CMakeLists.txt ===
set(include_directory ${CMAKE_CURRENT_SOURCE_DIR}/include-files)
set(library_directory ${CMAKE_CURRENT_SOURCE_DIR}/library)
set(config_directory  ${CMAKE_CURRENT_BINARY_DIR}/library)

if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Cray")
  configure_file(${include_directory}/cray_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
  configure_file(${include_directory}/intel_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
  configure_file(${include_directory}/gfortran_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "VisualAge|XL")
  configure_file(${include_directory}/ibm_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "PGI")
  configure_file(${include_directory}/portlandgroup_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "NAG")
  configure_file(${include_directory}/nag_capabilities.txt ${config_directory}/compiler_capabilities.txt COPYONLY)
else()
  message ("Unknown Fortran compiler: ${CMAKE_Fortran_COMPILER_ID}")
endif()

set(CMAKE_Fortran_COMPILER "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/caf")
add_executable(coarray_burgers_pde
  main.F90
  global_field.F90
  local_field.F90
  ${library_directory}/ForTrilinos_assertion_utility.F90
  ${library_directory}/object_interface.F90
  ${library_directory}/co_object_interface.F90
)
add_dependencies(coarray_burgers_pde caf_mpi_static)
target_include_directories(coarray_burgers_pde PRIVATE ${config_directory})

=== debian/changelog ===
open-coarrays (2.10.2+ds-4build1) questing; urgency=medium

  * No-change rebuild for gfortran 15.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Sep 2025 14:27:12 +0200

=== debian/control ===
# DON'T MANUALLY MODIFY!
# EDIT debian/control.in INSTEAD!
#
Source: open-coarrays
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
 mpi-default-dev,
 dh-sequence-fortran-mod,
 gfortran | fortran-compiler,
 libopenmpi-dev [alpha amd64 arm64 hurd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 libmpich-dev [alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 m68k mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc64 x32],
 cmake (>= 3.3.1), 
 openssh-client,
Standards-Version: 4.7.0
Homepage: https://www.opencoarrays.org/
Vcs-Browser: https://salsa.debian.org:/science-team/open-coarrays
Vcs-Git: https://salsa.debian.org:/science-team/open-coarrays.git -b debian/latest


Package: libcoarrays-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, ${fortran:Depends}
Description: Co-Array Fortran libraries 
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package contains shared development files (headers and fortran modules)

Package: libcoarrays-openmpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 hurd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran  | fortran-compiler, openmpi-bin,
 libcaf-openmpi-3t64 (= ${binary:Version}), libcoarrays-dev
Description: Co-Array Fortran libraries  - development files (OpenMPI)
 OpenCoArrays is an open-source software project that supports the 
 coarray Fortran (CAF) parallel programming features of the Fortran 2008 
 standard and several features proposed for Fortran 2015 in the draft 
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of OpenMPI.

Package: libcaf-openmpi-3t64
Provides: ${t64:Provides}
Replaces: libcaf-openmpi-3
Breaks: libcaf-openmpi-3 (<< ${source:Version})
Section: libs
Architecture: alpha amd64 arm64 hurd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Co-Array Fortran libraries  (OpenMPI)
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of OpenMPI.

Package: libcoarrays-mpich-dev
Section: libdevel
Architecture: alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 m68k mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran | fortran-compiler, mpich,
 libcaf-mpich-3t64 (= ${binary:Version}), libcoarrays-dev
Description: Co-Array Fortran libraries for - development files (MPICH)
 OpenCoArrays is an open-source software project that supports the 
 coarray Fortran (CAF) parallel programming features of the Fortran 2008 
 standard and several features proposed for Fortran 2015 in the draft 
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of MPICH MPI.

Package: libcaf-mpich-3t64
Provides: ${t64:Provides}
Replaces: libcaf-mpich-3
Breaks: libcaf-mpich-3 (<< ${source:Version})
Section: libs
Architecture: alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 loong64 m68k mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Co-Array Fortran libraries  (MPICH)
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for Fortran to build parallel
 CAF programs built on top of MPICH MPI.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/mpi-default-dev/debian_defaults

DEB_TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
VERSION:=$(shell dpkg-parsechangelog --show-field Version)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
DESTDIR:=$(CURDIR)/debian/tmp

AUTOGENERATED   := $(patsubst %.in,%,$(wildcard debian/*.in))

%: %.in
	sed -e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < $< | \
	sed -e 's%@VERSION@%${VERSION}%g'   | \
	sed -e 's%@GFORTRAN_VERSION@%${GFORTRAN_VERSION}%g' >  $@

# Set default f95 compiler
F95 ?= /usr/bin/f95

GFORTRAN_VERSION:=$(readlink /usr/bin/gfortran)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake --no-parallel 

# DISABLED_TESTS:= "powerpc alpha"

MPICH_CFLAGS=$(dpkg-buildpackage --get CFLAGS) $(shell pkg-config mpich --cflags)
MPICH_FCFLAGS=$(dpkg-buildpackage --get FCFLAGS) $(shell pkg-config mpich-fort --cflags)
OPENMPI_CFLAGS=$(dpkg-buildpackage --get CFLAGS) $(shell pkg-config ompi-c --cflags)
OPENMPI_FCFLAGS=$(dpkg-buildpackage --get FCFLAGS) $(shell pkg-config ompi-fort --cflags)

override_dh_auto_configure: $(AUTOGENERATED)
ifneq (,$(filter $(DEB_TARGET_ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	CXX=mpicxx.mpich CC=mpicc.mpich FC=mpif90.mpich  \
		dh_auto_configure --builddirectory=build-mpich -- \
			-DCAF_LIB_NAME=caf_mpich
endif
ifneq (,$(filter $(DEB_TARGET_ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	CXX=mpicxx.openmpi CC=mpicc.openmpi FC=mpif90.openmpi  \
		dh_auto_configure --builddirectory=build-openmpi -- 	\
			-DCAF_LIB_NAME=caf_openmpi
endif

override_dh_auto_build:
ifneq (,$(filter $(DEB_TARGET_ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	dh_auto_build --builddirectory=build-mpich
endif
ifneq (,$(filter $(DEB_TARGET_ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	dh_auto_build --builddirectory=build-openmpi
endif

override_dh_auto_install:
ifneq (,$(filter $(DEB_TARGET_ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	cp debian/caf.mpich build-mpich/bin/caf
	dh_auto_install --builddirectory=build-mpich
	mkdir -p $(DESTDIR)/$(LIBDIR)/open-coarrays/mpich/lib
	mv build-mpich/lib/$(DEB_HOST_MULTIARCH)/libopencoarrays_mod.a   $(DESTDIR)/$(LIBDIR)/open-coarrays/mpich/lib/libopencoarrays_mod_mpich.a
endif
ifneq (,$(filter $(DEB_TARGET_ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	cp debian/caf.openmpi build-openmpi/bin/caf
	dh_auto_install --builddirectory=build-openmpi
	mkdir -p  $(DESTDIR)/$(LIBDIR)/open-coarrays/openmpi/lib/
	mv build-openmpi/lib/$(DEB_HOST_MULTIARCH)/libopencoarrays_mod.a $(DESTDIR)/$(LIBDIR)/open-coarrays/openmpi/lib/libopencoarrays_mod_openmpi.a
endif
	rm  $(DESTDIR)/$(LIBDIR)/libopencoarrays_mod.a

override_dh_auto_clean:
	dh_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -rf build-*
	@echo "Generating the control file..."
	echo "# DON'T MANUALLY MODIFY!" > debian/control.tmp
	echo "# EDIT debian/control.in INSTEAD!" >> debian/control.tmp
	echo "#" >> debian/control.tmp
	cat debian/control.in >> debian/control.tmp
	sed -i "s,%SUPPORTED_ARCHITECTURES%,$(strip $(sort $(OPENMPI_ARCHITECTURES) $(MPICH_ARCHITECTURES))),g" debian/control.tmp
	sed -i "s,%OPENMPI_ARCHITECTURES%,$(strip $(sort $(OPENMPI_AVAILABLE_ARCHITECTURES))),g" debian/control.tmp
	sed -i "s,%MPICH_ARCHITECTURES%,$(strip $(sort $(MPICH_AVAILABLE_ARCHITECTURES))),g" debian/control.tmp
	set -e ; if ! diff -q debian/control debian/control.tmp > /dev/null; then \
		echo ;\
		echo "The generated control file differs from the actual one." ;\
		echo "A sourceful upload of this package is needed." ;\
		echo ;\
		echo "Differences:" ;\
		diff -u debian/control debian/control.tmp ;\
	else \
		rm debian/control.tmp ;\
	fi


override_dh_auto_test:
ifneq (,$(findstring  "$(DEB_TARGET_ARCH)",$(DISABLED_TESTS)))
	@echo "Tests disabled on this arch: known failures being investigated"
else
	@echo "Tests may hang/timeout due to lack of processors. "
	-dh_auto_test --timeout 30
endif
